import requests
import json
from email.message import EmailMessage
import smtplib

send_mail = False

def send_email(content):
    email_list = ['jerzy.andrzejewski@shumee.pl', 'filip.marciniak@shumee.pl']
    gmail_user = 'jerzy.andrzejewski@shumee.pl'
    gmail_password = '5ShuM33!pl'
    
    for email in email_list:
        
        msg = EmailMessage()
        msg.set_content(content)

        # me == the sender's email address
        # you == the recipient's email address
        msg['Subject'] = 'CDON problem z aktualizacją'
        msg['From'] = gmail_user
        msg['To'] = email

        #try:
        server = smtplib.SMTP_SSL('serwer1694120.home.pl', 465)
        server.ehlo()
        server.login(gmail_user, gmail_password)
        server.send_message(msg)
        server.close()

        print ('Email sent!')
        
def make_api_request(api_token, endpoint, xml_file_path):
    global send_mail
    mail_str = ""
    # Set the API endpoint
    url = f"https://mis.cdon.com/{endpoint}"

    # Set the Authorization header with the API Token
    headers = {
        "Authorization": f"api {api_token}",
        "Content-Type": "application/xml"  # Set the content type for XML
    }

    try:
        # Read the content of the XML file
        with open(xml_file_path, 'rb') as file:
            xml_content = file.read()

        # Make the API request with the XML content
        response = requests.post(url, headers=headers, data=xml_content)

        # Check for successful response (status code 2xx)
        if response.status_code // 100 == 2:
            print(f"{xml_file_path} Request successful!")
            print(f"{xml_file_path} Response:", response.text)
        else:
            print(f"{xml_file_path} Request failed with status code {response.status_code}")
            print(f"{xml_file_path} Response:", response.text)
        mail_str += f"{xml_file_path} " + response.text + '\n'
        headers['Content-Type'] = 'application/json'
        r = requests.get(json.loads(response.text)['statusUrl'], headers=headers)
        print(r.text)
        try:
            if int(json.loads(r.text)['Code']) // 100 != 2:
                mail_str += f"{xml_file_path} " + r.text+'\n'
                print(r.text)
                send_mail = True
        except:
            pass

    except requests.RequestException as e:
        print(f"Request error: {e}")
    return mail_str

def execute():
    mail_str = ""
    prices_to_send = ['feeds/prices0.xml', 'feeds/prices1.xml', 'feeds/prices2.xml', 'feeds/prices3.xml', 'feeds/prices4.xml']
    stocks_to_send = ['feeds/stocks0.xml', 'feeds/stocks1.xml', 'feeds/stocks2.xml', 'feeds/stocks3.xml', 'feeds/stocks4.xml']
    api_token = 'ba791792-c949-4baa-ac8d-253c9805120a'
    for xml_file_path in prices_to_send:
        mail_str += make_api_request(api_token, 'price', xml_file_path)
    for xml_file_path in stocks_to_send:
        mail_str += make_api_request(api_token, 'availability', xml_file_path)
    if send_mail == True:
        send_email(mail_str)
    
if __name__ == "__main__":
    execute()
